﻿using System;
using System.Diagnostics;
using System.IO;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.AppStyling;
using Infragistics.Win.AppStyling.Runtime;
using Infragistics.Win.UltraWinGrid;
using Infragistics.Win.UltraWinEditors;
using System.Drawing.Imaging;
using Infragistics.Win.SupportDialogs.FilterUIProvider;

namespace HasRowElement
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.grid.DataSource = this.Table;
            this.grid.CreationFilter = new RowUIElementCreationFilter();
        }

        private DataTable Table
        {
            get
            {
                DataTable table = new DataTable();

                table.Columns.Add("Name", typeof(string));
                table.Columns.Add("Number", typeof(int));

                for ( int i = 0; i < 1000; i ++ )
                {
                    table.Rows.Add( new object[]{ i.ToString(), i } );
                }


                return table;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            RowUIElementCreationFilter filter = this.grid.CreationFilter as RowUIElementCreationFilter;

            int value = 0;
            if ( int.TryParse(this.textBox1.Text, out value) &&
                 value >= 0 && value < this.grid.Rows.Count )
            {
                if ( filter.HasElement(this.grid.Rows[value]) )
                    MessageBox.Show("yep");
                else
                    MessageBox.Show("nope");
            }
        }
    }

    public class RowUIElementCreationFilter : IUIElementCreationFilter
    {
        private HashSet<UltraGridRow> lookup = null;

        private HashSet<UltraGridRow> Lookup
        {
            get
            {
                if ( this.lookup == null )
                    this.lookup = new HashSet<UltraGridRow>();

                return this.lookup;
            }
        }

        public bool HasElement(UltraGridRow row)
        {
            if ( row == null )
                return false;

            return this.Lookup.Contains(row);
        }

        #region IUIElementCreationFilter
        void IUIElementCreationFilter.AfterCreateChildElements(UIElement parent)
        {
            RowUIElement rowElement = parent as RowUIElement;
            if ( rowElement != null )
                this.Lookup.Add(rowElement.Row);
        }

        bool IUIElementCreationFilter.BeforeCreateChildElements(UIElement parent)
        {
            return false;
        }
        #endregion IUIElementCreationFilter
    }

}
